Module | Merb::Template
In: | lib/merb-core/controller/template.rb

### Methods

engine_for inline_template load_template_io needs_compilation? register_extensions template_extensions template_for template_name

### Classes and Modules

Class Merb::Template::Erubis

### Constants

EXTENSIONS | = | {} unless defined?(EXTENSIONS)
METHOD_LIST | = | {} unless defined?(METHOD_LIST)
SUPPORTED_LOCALS_LIST | = | Hash.new([].freeze) unless defined?(SUPPORTED_LOCALS_LIST)
MTIMES | = | {} unless defined?(MTIMES)

### Public Class methods

engine_for(path)

Finds the engine for a particular path.

#### Parameters

path<String>: | The path of the file to find an engine for.

#### Returns

Class: | The engine.

:api: private

inline_template(io, locals=[], mod = Merb::InlineTemplates)

Takes a template at a particular path and inlines it into a module and adds it to the METHOD_LIST table to speed lookup later.

#### Parameters

io<path>: | An IO that responds to path (File or VirtualFile)
locals<Array[Symbol]>: | A list of local names that should be assigned in the template method from the arguments hash. Defaults to [].
mod<Module>: | The module to put the compiled method into. Defaults to Merb::InlineTemplates

#### Returns

Symbol: | The name of the method that the template was compiled into.

#### Notes

Even though this method supports inlining into any module, the method must be available to instances of AbstractController that will use it.

:api: private

load_template_io(path)

For a given path, get an IO object that responds to path.

This is so that plugins can override this if they provide mechanisms for specifying templates that are not just simple files. The plugin is responsible for ensuring that the fake path provided will work with template_for, and thus the RenderMixin in general.

#### Parameters

path<String>: | A full path to find a template for. This is the

      path that the RenderMixin assumes it should find the template
      in.

#### Returns

IO#path: | An IO object that responds to path (File or VirtualFile).

:api: plugin @overridable

needs_compilation?(path, locals)

Decide if a template needs to be re/compiled.

#### Parameters

path<String>: | The full path of the template to check support for.
locals<Array[Symbol]>: | The list of locals that need to be supported

#### Returns

Boolean: | Whether or not the template for the provided path needs to be recompiled

:api: private

register_extensions(engine, extensions)

Registers the extensions that will trigger a particular templating engine.

#### Parameters

engine<Class>: | The class of the engine that is being registered
extensions<Array[String]>: | The list of extensions that will be registered with this templating language

#### Raises

ArgumentError: | engine does not have a compile_template method.

#### Returns

nil

#### Example

      Merb::Template.register_extensions(Merb::Template::Erubis, ["erb"])

:api: plugin

template_extensions()

Get all known template extensions

#### Returns

      Array:: Extension strings.

:api: plugin

template_for(path, template_stack = [], locals=[])

Get the name of the template method for a particular path.

#### Parameters

path<String>: | A full path to find a template method for.
template_stack<Array>: | The template stack. Not used.
locals<Array[Symbol]>: | The names of local variables

#### Returns

<String>: | name of the method that inlines the template.

:api: private

template_name(path)

Get the template‘s method name from a full path. This replaces non-alphanumeric characters with __ and "." with "_"

Collisions are potentially possible with something like: ~foo.bar and __foo.bar or !foo.bar.

#### Parameters

path<String>: | A full path to convert to a valid Ruby method name

#### Returns

String: | The template name.

We might want to replace this with something that varies the character replaced based on the non-alphanumeric character to avoid edge-case collisions.

:api: private

[Validate]